#include "CHMpreCompHead.h"
#pragma hdrstop

#include <CHM/CHMmessageDef.h>
#include <CHM/CHMmessageDefClass.h>
#include <assert.h>

//---------------------------------------------------------------------------------
// implementation private class
class CHMmessageDefinitionPrivate
{
public:
   CHMmessageDefinitionPrivate(CHMmessageHandle Handle);
   ~CHMmessageDefinitionPrivate();

   CHMmessageHandle  MessageDefHandle;
};

CHMmessageDefinitionPrivate::CHMmessageDefinitionPrivate
(
   CHMmessageHandle Handle
) : MessageDefHandle(Handle) 
{
   assert(Handle != NULL);
}

CHMmessageDefinitionPrivate::~CHMmessageDefinitionPrivate()
{
}

//---------------------------------------------------------------------------------
CHMmessageDefinition::CHMmessageDefinition
(
   CHMmessageHandle Handle
) : pMember(NULL)
{  
   pMember = new CHMmessageDefinitionPrivate(Handle);
}

CHMmessageDefinition::CHMmessageDefinition() : pMember(NULL)
{
   pMember = new CHMmessageDefinitionPrivate(NULL);
}

CHMmessageDefinition::~CHMmessageDefinition()
{
   delete pMember;
}

const char* CHMmessageDefinition::GetMessageName() const
{
   const char* pName;
   CHM_CHECK_CALL(CHMmessageGetName(GetMessageDefHandle(), &pName));
   return pName;
}

const char* CHMmessageDefinition::GetMessageDescription() const
{
   const char* pDescription;
   CHM_CHECK_CALL(CHMmessageGetDescription(GetMessageDefHandle(), &pDescription));
   return pDescription;
}


CHMmessageHandle CHMmessageDefinition::GetMessageDefHandle() const
{
   return pMember->MessageDefHandle; 
}

CHMtableGrammarHandle CHMmessageDefinition::GetTableGrammar() const
{
   CHMtableGrammarHandle TableGrammarHandle;
   CHM_CHECK_CALL(CHMmessageGetTableGrammar(GetMessageDefHandle(), &TableGrammarHandle));
   return TableGrammarHandle;
}
